<div class="venta-container">

  <h4>Ventas solicitadas</h4>

  <ng-container *ngIf="ventas.length; else mensaje">
    <p-table #dt [value]="ventas" [rows]="10" [paginator]="true"
      [globalFilterFields]="['codigo']"
      [tableStyle]="{ 'min-width': '75rem' }" [rowHover]="true" dataKey="id"
      currentPageReportTemplate="Mostrando del {first} al {last} de {totalRecords} resultados"
      [showCurrentPageReport]="true">
      <ng-template pTemplate="caption">
        <div class="buscador flex align-items-center justify-content-between">
          <span class="span-buscador">
            <i class="pi pi-search"></i>
            <input class="inpt_secon" type="text" placeholder="Buscar por el código de Venta" (input)="busqueda($event)" />
          </span>

          <p-dropdown [options]="estados" class="inpt_secon w-pdd" (onChange)="filtrarVentas($event.value)" [showClear]="true"
            placeholder="Filtrar por estado">
          </p-dropdown>
        </div>
      </ng-template>

      <ng-template pTemplate="header">
        <tr>
          <th pSortableColumn="detalle.codigo">Código Venta<p-sortIcon field="detalle.codigo"></p-sortIcon></th>
          <th pSortableColumn="Usuario">Cliente<p-sortIcon field="Usuario"></p-sortIcon></th>
          <th pSortableColumn="Producto">Producto<p-sortIcon field="Producto"></p-sortIcon></th>
          <th pSortableColumn="detalle.Cantidad">Cantidad<p-sortIcon field="detalle.Cantidad"></p-sortIcon></th>
          <th pSortableColumn="detalle.SubTotal">Total<p-sortIcon field="detalle.SubTotal"></p-sortIcon></th>
          <th pSortableColumn="detalle.fechaRegistro">Fecha de venta<p-sortIcon field="detalle.fechaRegistro"></p-sortIcon></th>
          <th pSortableColumn="detalle.estado">Estado<p-sortIcon field="detalle.estado"></p-sortIcon></th>
          <th></th>
        </tr>
      </ng-template>

      <ng-template pTemplate="body" let-venta>
        <tr>
          <td>{{ venta.detalle.Codigo }}</td>
          <td>{{ venta.Usuario }}</td>
          <td>{{ venta.Producto }}</td>
          <td>{{ venta.detalle.Cantidad }}</td>
          <td>{{ venta.detalle.SubTotal }} Bs.</td>
          <td>{{ obtenerFecha(venta.detalle.fechaRegistro) }}</td>
          <td><span [class]="obtenerColorEstado(venta.detalle.Estado)">{{ obtenerEstadoVenta(venta.detalle.Estado) }}</span></td>
          <td class="flex gap-3">
            <button pButton icon="pi pi-eye" class="btn p-button-rounded" pTooltip="Ver detalle de la venta"
              tooltipPosition="left" (click)="mostrarDetalleVenta(venta)"></button>
          </td>
        </tr>
      </ng-template>

      <ng-template pTemplate="summary">
        <div class="flex align-items-center justify-content-between">En total hay {{ ventas.length }} ventas.</div>
      </ng-template>
    </p-table>
  </ng-container>

  <ng-template #mensaje>
    <div class="mensaje">
      <p>No se encontraron ventas</p>
    </div>
  </ng-template>
</div>

<!-- Dialog detalle ventas -->

<div class="dialog-container-general">
  <p-dialog header="Detalle de la venta" [(visible)]="dialogDetalleVenta" [style]="{width: '40vw'}" [modal]="true"
    class="modal-container">
    <div class="detalleVenta">
      <div class="fila">
        <span><label>Codigo de venta</label>{{ venta.detalle.Codigo }}</span>
      </div>

      <div class="fila">
        <span><label>Cliente</label>{{ venta.Usuario }}</span>
        <span>
          <label>Celular:</label>
          <a class="link_style" href="https://wa.me/{{ venta.Telefono}}" target="_blank">
            <i class="uil uil-whatsapp"></i> {{ venta.Telefono }}
          </a>
        </span>
      </div>

      <div class="fila">
        <span><label>Producto</label>{{ venta.Producto }}</span>
        <span><label>Cantidad</label>{{ venta.detalle.Cantidad }}</span>
      </div>

      <div class="fila">
        <span><label>Precio (Bs)</label>{{ venta.detalle.PrecioUnitario }}</span>
        <span><label>Total (Bs)</label>{{ venta.detalle.SubTotal }}</span>
      </div>

      <div class="fila">
        <span><label>Fecha de venta</label>{{ obtenerFecha(venta.detalle.fechaRegistro) }}</span>
        <span>
          <label>Estado</label>
          <span [class]="obtenerColorEstado(venta.detalle.Estado)" class="estado">
            {{obtenerEstadoVenta(venta.detalle.Estado)}}
          </span>
        </span>
      </div>
    </div>

    <ng-template pTemplate="footer">
      <div class="flex gap-3 justify-content-center" *ngIf="venta.detalle.Estado !== '3' && venta.detalle.Estado !== '4'">
        <button pButton type="button" label="{{venta.detalle.Estado === '1' ? 'Listo para entregar' : 'Entregado'}}" (click)="actualizarEstadoVenta(venta)" class="btn"></button>
      </div>
    </ng-template>
  </p-dialog>
